import 'package:ez_flutter_common/config/ez_config.dart';
import 'package:flutter/material.dart';

/**
 * todo 项目全局 颜色管理
 * @author lijinwei
 * @date 2021-07-01
 */
class EzColor{
  // 颜色类型 ================================
  static const String C_T_LIGHT = "LIGHT";
  static const String C_T_DARK = "DARK";

  // 文字颜色 ================================
  static const String T_C_1 = "T_C_1";
  static const String T_C_2 = "T_C_2";
  static const String T_C_3 = "T_C_3";

  // 背景颜色 ================================
  static const String BG_C_1 = "BG_C_1";
  static const String BG_C_2 = "BG_C_2";
  static const String BG_C_INPUT = "BG_C_INPUT";

  // 主颜色 ================================
  static const String MAIN_C_1 =  "MAIN_C_1";
  static const String MAIN_C_2 =  "MAIN_C_2";
  static const String MAIN_C_3 =  "MAIN_C_3";


  static Map _colorCfg = {
    T_C_1: {C_T_LIGHT: Color(0xff222333), C_T_DARK: Color(0xffd1d4d8),},
    T_C_2: {C_T_LIGHT: Color(0xff585858), C_T_DARK: Color(0xffb2b4b9),},
    T_C_3: {C_T_LIGHT: Color(0xffa6a6a6), C_T_DARK: Color(0xff82858c),},
    BG_C_1: {C_T_LIGHT: Color(0xffffffff), C_T_DARK: Color(0xff19191f),},
    BG_C_2: {C_T_LIGHT: Color(0xfff9f9f9), C_T_DARK: Color(0xff0e0e0f),},
    BG_C_INPUT: {C_T_LIGHT: Color(0xfff4f4f4), C_T_DARK: Color(0xff26262b),},
    MAIN_C_1: {C_T_LIGHT: Color(0xff222222), C_T_DARK: Color(0xffeeeeee),},
    MAIN_C_1: {C_T_LIGHT: Color(0xff222222), C_T_DARK: Color(0xffeeeeee),},
    MAIN_C_1: {C_T_LIGHT: Color(0xff222222), C_T_DARK: Color(0xffeeeeee),},
  };

  // todo 设置颜色 map
  static setColorMap(Map map){
    _colorCfg = map;
  }

  // todo 设置颜色
  static setColor(String key,String type,Color color){
    if(_colorCfg[key] == null){
      _colorCfg[key] = {};
    }
    _colorCfg[key][type] = color;
  }

  // todo 设置颜色 Int
  static setColorInt(String key,String type,int color){
    if(_colorCfg[key] == null){
      _colorCfg[key] = {};
    }
    _colorCfg[key][type] = Color(color);
  }

  // todo 获取颜色
  static getC(String key, {String type}){
    type = type ?? EzG.colorType;
    return _colorCfg[key][type];
  }

}