import 'package:ez_flutter_common/config/ez_color.dart';
import 'package:flutter/cupertino.dart';
/**
 * todo ezcool 配置文件
 * @author lijinwei
 * @date 20210-06-29
 */
class EzConfig{
  // 全局context
  static BuildContext gContext = null;
  // 屏幕信息相关
  static double bottomBarHeight = 0;
  static double statusBarHeight = 0;
  static double scSp = 1.0;
  static double scW = 1.0;
  static String _colorType = EzColor.C_T_LIGHT;

  static String get colorType => _colorType;
  static bool _isDark = false;
  static bool get isDark => _isDark;


  // todo 设置全局context
  static void setGcontext(BuildContext context){
    EzConfig.gContext = context;
  }

  static void setColorType(String colorType,{bool isDark}){
    _colorType = colorType;
    if(isDark != null){
      _isDark = isDark;
    }else{
      if(EzConfig.colorType == EzColor.C_T_LIGHT){
        EzConfig._isDark = false;
      }else if(EzConfig.colorType == EzColor.C_T_DARK){
        EzConfig._isDark = true;;
      }
    }
  }


  // todo 设置屏幕信息
  static void setScreenInfo({double scW,double scSp,double bottomBarHeight,double statusBarHeight}){
    EzConfig.scW = scW ?? EzConfig.scW;
    EzConfig.scSp = scSp ?? EzConfig.scSp;
    EzConfig.bottomBarHeight = bottomBarHeight ?? EzConfig.bottomBarHeight;
    EzConfig.statusBarHeight = statusBarHeight ?? EzConfig.statusBarHeight;
  }
}

/**
 * todo ezcool 全局访问对象
 * @author lijinwei
 * @date 20210-06-29
 */
class EzG{
  static double gSp(double sp) => EzConfig.scSp * sp;
  static double gW(double w) => EzConfig.scW * w;
  static BuildContext get gContext => EzConfig.gContext;
  static double get bottomBarHeight => EzConfig.bottomBarHeight;
  static double get statusBarHeight => EzConfig.statusBarHeight;
  static String get colorType => EzConfig.colorType;
  static bool get isDark => EzConfig.isDark;
  static Color getC(String key, {String type}) => EzColor.getC(key,type:type);
}
