import 'dart:convert';

/**
 * todo String 工具类
 * @authhor lijinwei
 * @date 2020-06-23
 */
class EzStrUtil {
  static String getWorksShowTitle(String title, String content,
      {int length = 50}) {
    if (title.isNotEmpty) {
      return title;
    } else if (content.isNotEmpty) {
      length = length ?? 50;
      if (content.length > length) {
        return content.substring(0, length);
      } else {
        return content;
      }
    }
  }

  static String toBase64(String text) {
    print(text);
    if (isEmpty(text)) {
      return "";
    }
    var _content = utf8.encode(text);
    var _digest = base64Encode(_content);
    return _digest;
  }

  // TODO 字符串为空判断
  static bool isEmpty(dynamic data) {
    if (data == null || data == 'null') {
      return true;
    }
    if ("${data}" == '' || "${data}".length <= 0) {
      return true;
    }
    return false;
  }

  // TODO 字符串不为空判断
  static bool isNotEmpty(dynamic data) {
    return !isEmpty(data);
  }

  ///大陆手机号码11位数，匹配格式：前三位固定格式+后8位任意数
  /// 此方法中前三位格式有：
  /// 13+任意数 * 15+除4的任意数 * 18+除1和4的任意数 * 17+除9的任意数 * 147
  static bool isChinaPhoneLegal(String str) {
    return new RegExp(
            '^((13[0-9])|(15[^4])|(166)|(17[0-8])|(18[0-9])|(19[8-9])|(147,145))\\d{8}\$')
        .hasMatch(str);
  }

  static List<EzKeyText> getKeyList(String text, String keyWords,
      {int maxNum = 100}) {
    String _newText = text.length > maxNum ? text.substring(0, maxNum) : text;
    List<String> _keyTextList = _newText.split(keyWords);
    List<EzKeyText> _result = [];
    for (String value in _keyTextList) {
      _result.add(EzKeyText(false, value));
      _result.add(EzKeyText(true, keyWords));
    }
//    _result.removeLast();
    return _result;
  }

  // TODO 秒转时分
  static String second2HMS(int sec, {bool isEasy = true}) {
    String hms = "00:00:00";
    if (!isEasy) hms = "00时00分00秒";
    if (sec > 0) {
      int h = sec ~/ 3600;
      int m = (sec % 3600) ~/ 60;
      int s = sec % 60;
      hms = "${zeroFill(h)}:${zeroFill(m)}:${zeroFill(s)}";
      if (!isEasy) hms = "${zeroFill(h)}时${zeroFill(m)}分${zeroFill(s)}秒";
    }
    return hms;
  }

  // TODO 补零
  static String zeroFill(int i) {
    return i >= 10 ? "$i" : "0$i";
  }
}

class EzKeyText {
  bool isKey;
  String text;

  EzKeyText(this.isKey, this.text);
}

void main() {
  print(EzStrUtil.toBase64("nullxxx"));
}
