import 'package:flutter/cupertino.dart';

import 'ez_str_util.dart';

EzSetTimeOut(int time,Function fun) async {
 return await Future.delayed(Duration(milliseconds: time), () async {
   if(fun != null){
     await fun();
   }else{
     print("EzSetTimeOut=方法为空啦");
   }
  });
}
class EzTimeUtil{

  static int currentTimeMillis() {
    return new DateTime.now().millisecondsSinceEpoch;
  }
  // todo 生日转年龄
  static String birthday2Age(String birthday,{bool showMonth}){
    showMonth = showMonth ?? false;
    if(EzStrUtil.isEmpty(birthday)){return "0岁";}
    DateTime dateTime;
    try{dateTime = DateTime.parse(birthday);}catch(e){print(e);return "0岁";}
    DateTime nowDate = new DateTime.now();
    // 年份差
    int ageYear = nowDate.year - dateTime.year;
    // 根据月份计算 整年 年龄
    if(nowDate.month < dateTime.month){
      ageYear = ageYear - 1;
    }
    // 月份差
    int ageMonth = nowDate.month - dateTime.month;
    if(nowDate.month < dateTime.month){
      ageMonth = (12 - dateTime.month) + nowDate.month;
    }
    String ageStr = '${ageYear}岁';

    if(showMonth && ageMonth > 0){
      if(ageYear <= 0){
        ageStr = "";
      }
      ageStr = "${ageStr}${ageMonth}个月";
    }
    return ageStr;
  }

  // todo 生日转星座
  static String birtyday2Constellation(String birthday){
    if(EzStrUtil.isEmpty(birthday)){return "未知";}
    DateTime dateTime;
    try{dateTime = DateTime.parse(birthday);}catch(e){print(e);return "未知";}
    const Map xingZuoMap = {
      '1': {'start': 20,'name': '水瓶座'},
      '2': {'start': 19,'name': '双鱼座'},
      '3': {'start': 21,'name': '白羊座'},
      '4': {'start': 20,'name': '金牛座'},
      '5': {'start': 21,'name': '双子座'},
      '6': {'start': 22,'name': '巨蟹座'},
      '7': {'start': 23,'name': '狮子座'},
      '8': {'start': 23,'name': '处女座'},
      '9': {'start': 23,'name': '天秤座'},
      '10': {'start': 24,'name': '天蝎座'},
      '11': {'start': 23,'name': '射手座'},
      '12': {'start': 22,'name': '摩羯座'},
    };
    // 获取生日所在月份数据
    int xMonth = dateTime.month;
    Map data = xingZuoMap['${xMonth}'];
    if(dateTime.day < data['start']){
      xMonth = xMonth == 1 ? 12: xMonth - 1;
      data = xingZuoMap['${xMonth}'];
    }
    return data['name'];
  }

  // todo showTime
  static String dt2ShowTime(String date,{bool isC}){
    isC ?? false;
    try{
      DateTime dateTime = DateTime.parse(date);
      return dt2SendTime(dateTime,isC: isC);
    }catch(e){
      print(e);
      print("解析失败的日期=${date}");
      return '未知';
    }
  }

  // todo showTime
  static String dt2ShowDate(String date,{bool isC}){
    isC = isC ?? false;
    try{
      DateTime dateTime = DateTime.parse(date);
      return '${dateTime.month}${isC ? '月':'-'}${dateTime.day}${isC ? '日':''}';
    }catch(e){
      print(e);
      print("解析失败的日期=${date}");
      return '未知';
    }
  }

  // todo 发送时间
  static String dt2SendTime(DateTime sendtime,{bool isC}){
    isC ?? false;

    DateTime nowTime = DateTime.now();
    String showTime = '现在';

    // 判断发送时间是否在10分钟内
    if(sendtime.isAfter(nowTime.add(Duration(minutes: -3)))){
      showTime = '刚刚';
      return showTime;
    }
//
//    // 判断发送时间是在1小时内
//    if(sendtime.isAfter(nowTime.add(Duration(minutes: -60)))){
//      int countminutes = nowTime.difference(sendtime).inMinutes;
//      showTime = '${countminutes}分钟前';
//      return showTime;
//    }
    if(sendtime.isAfter(nowTime.add(Duration(minutes: -60)))){
      int countminutes = nowTime.difference(sendtime).inMinutes;
      showTime = '${countminutes}分钟前';
      return showTime;
    }
    // 判断发送时间是否在1天内
    if(sendtime.isAfter(DateTime(nowTime.year,nowTime.month,nowTime.day))){
      showTime = '今天'+ '${sendtime.hour>=10?sendtime.hour:'0${sendtime.hour}'}:${sendtime.minute>=10?sendtime.minute:'0${sendtime.minute}'}';
      return showTime;
    }

    DateTime yesterday = nowTime.add(Duration(days: -1));
    // 判断发送时间是否在是昨天  .day - sendtime.day <2
    if(sendtime.isAfter(DateTime(yesterday.year, yesterday.month, yesterday.day))){
      showTime = '昨天'+'${sendtime.hour>=10?sendtime.hour:'0${sendtime.hour}'}:${sendtime.minute>=10?sendtime.minute:'0${sendtime.minute}'}';
      return showTime;
    }

    DateTime yester2day = nowTime.add(Duration(days: -2));
    // 判断发送时间是否在是前天  .day - sendtime.day <2
    if(sendtime.isAfter(DateTime(yester2day.year, yester2day.month, yester2day.day))){
      showTime = '前天'+'${sendtime.hour>=10?sendtime.hour:'0${sendtime.hour}'}:${sendtime.minute>=10?sendtime.minute:'0${sendtime.minute}'}';
      return showTime;
    }

    // 判断发送时间是否在是前天之前  .day - sendtime.day <2
    if(sendtime.isBefore(DateTime(yester2day.year, yester2day.month, yester2day.day))){
      showTime =!(isC ?? false) ? "${sendtime.month>=10?sendtime.month:'0${sendtime.month}'}-${sendtime.day>=10?'${sendtime.day}':'0${sendtime.day} '}"
            : "${sendtime.month}月${sendtime.day}日";
//          '${sendtime.hour>=10?sendtime.hour:'0${sendtime.hour}'}:${sendtime.minute>=10?sendtime.minute:'0${sendtime.minute}'}';
      return showTime;
    }
  }

  // todo 发送日期
  static int dayFromStr(String date){
    DateTime dateTime;
    try{
      dateTime = DateTime.parse(date);
    }catch(e){
      return null;
    }
    return dateTime.day;
  }

  // todo 发送月份
  static int monthFromStr(String date){
    DateTime dateTime;
    try{
      dateTime = DateTime.parse(date);
    }catch(e){
      return null;
    }
    return dateTime.month;
  }

  // todo video time
  static String videoFormatDuration(Duration position) {
    final ms = position.inMilliseconds;

    int seconds = ms ~/ 1000;
    final int hours = seconds ~/ 3600;
    seconds = seconds % 3600;
    var minutes = seconds ~/ 60;
    seconds = seconds % 60;

    final hoursString = hours >= 10 ? '$hours' : hours == 0 ? '00' : '0$hours';

    final minutesString =
    minutes >= 10 ? '$minutes' : minutes == 0 ? '00' : '0$minutes';

    final secondsString =
    seconds >= 10 ? '$seconds' : seconds == 0 ? '00' : '0$seconds';

    final formattedTime =
        '${hoursString == '00' ? '' : hoursString + ':'}$minutesString:$secondsString';

    return formattedTime;
  }
}

// void main(){
//   print(EzTimeUtil.birtyday2Constellation("2018-01-02"));
// }