import 'package:ez_flutter_common/model/ez_load_state.dart';
import 'package:flutter/material.dart';

class EzPagelistM<T>{
  bool isSuc;
  List<T> data;
  int totalPage;
  int totalItem;
  int currentPage;
  EzPagelistM({this.isSuc,this.data,this.totalPage:0,this.currentPage:1,this.totalItem:0});
}

typedef Future<EzPagelistM> EzPagelistLoadDataFun(int pageNo,int pageSize);

class EzPagelistController<T> extends ChangeNotifier{
  List<T> listData = [];
  EzLoadState loadState = new EzLoadState();
  EzPagelistLoadDataFun loadDataFun;
  int pageNo = 1;
  int pageSize = 10;
  bool refreshClear;

  ValueNotifier<int> valueVn = new ValueNotifier(1);
  EzPagelistController(this.loadDataFun, {this.pageSize: 10,this.pageNo: 1,this.refreshClear: false});

  init(){
    refresh();
  }

  // todo 加载更多
  loadMore() async {
    pageNo +=1;
    EzPagelistM ezListM = await _loadData(pageNo,pageSize);
    if(ezListM.isSuc){
      List<T> _listData = ezListM.data;
      if(ezListM.data.length > 0){
        listData.addAll(_listData);
      }else{
        pageNo -=1;
        loadState.toNomore();
      }
    }
    notifyListeners();
  }

  // todo 刷新列表
  Future<bool> refresh() async {
    // print("!loadState.isLoad && listData.length <= 0=${!loadState.isLoad && listData.length <= 0}");
    if(!loadState.isLoad && listData.length <= 0){
      loadState.toLoad();
    }
    pageNo = 1;
    EzPagelistM ezListM = await _loadData(pageNo,pageSize);
    if(ezListM.isSuc){
      listData = ezListM.data;
      if(listData.length > 0){
        loadState.toSuc();
      }else{
        loadState.toNodata();
      }
    }else{
      loadState.toFail();
    }
    notifyListeners();
  }

  notifyListeners(){
    if(listData.length <=0 && (loadState.isSuc || loadState.isNomore)){
      loadState.toNomore();
    }
    valueVn.notifyListeners();
  }

  Future<EzPagelistM> _loadData(int pageNo,int pageSize) async {
    try{
      EzPagelistM ezListM = await loadDataFun(pageNo,pageSize);
      return ezListM;
    }catch(e){
      print("EzListController=>_loadData=>出现错误");
      pageNo = pageNo - 1;
      return EzPagelistM(isSuc: false,);
    }
  }

}