import 'package:ez_flutter_common/config/ez_color.dart';
import 'package:ez_flutter_common/config/ez_config.dart';
import 'package:ez_flutter_common/config/ez_load_cfg.dart';
import 'package:ez_flutter_common/model/ez_load_state.dart';
import 'package:flutter/cupertino.dart';

/**
 * todo ez 状态组件，结合 ezLoadState 进行自动响应
 * @author 李金伟
 * @date 20210629
 */
class EzStateView extends StatelessWidget{

  EzLoadState ezLoadState;
  Widget Function(BuildContext context) builder;
  Function reloadFun;
  Widget Function(Function reloadFun) nodataViewFun;
  Widget Function(Function reloadFun) faildViewFun;
  Widget Function() loadViewFun;
  double pBottom;

  EzStateView(
      this.ezLoadState,
      {
        this.builder,
        this.reloadFun,
        this.faildViewFun,
        this.nodataViewFun,
        this.loadViewFun,
        this.pBottom = 0
      });

  @override
  Widget build(BuildContext context) {
    // TODO: implement build
    return ValueListenableBuilder(
        valueListenable: ezLoadState.valueVn,
        builder: (BuildContext context,value, Widget oChild){
          // print("EzStateView=>value=>${value}");
          return ezLoadState.isSuc ? builder(context)
              : Container(
                  padding: EdgeInsets.only(bottom: pBottom),
                  child: ezLoadState.isLoad ? loadViewFun == null ? EzStateVCfg.defCfg.loadViewFun() : loadViewFun()
                       : ezLoadState.isNodata ? nodataViewFun == null ? EzStateVCfg.defCfg.nodataViewFun(reloadFun):nodataViewFun(reloadFun)
                       : faildViewFun == null ? EzStateVCfg.defCfg.faildViewFun(reloadFun): faildViewFun(reloadFun),
          );
        }
    );
  }
}

/**
 * todo ez 状态组件配置文件
 * @author 李金伟
 * @date 20210629
 */
class EzStateVCfg{

  static EzStateVCfg _defCfg = EzStateVCfg(
      loadViewFun: buildLoadView,
      nodataViewFun: buildNodataView,
      faildViewFun: buildFaildView
  );

  static get defCfg => _defCfg;
  static setDefCfg(EzStateVCfg cfg){
    _defCfg = cfg;
  }

  // 加载视图
  Widget Function() loadViewFun;
  // 构建暂无数据视图方法
  Widget Function(Function reloadFun) nodataViewFun;
  // 构建加载失败视图方法
  Widget Function(Function reloadFun) faildViewFun;

  EzStateVCfg({this.loadViewFun,this.nodataViewFun,this.faildViewFun});

  static Widget buildLoadView(){
    return Container(
      child: Center(
        child: Column(
          children: [
            Expanded(child: Container()),
            Container(
              height: EzG.gW(80),
              width: EzG.gW(80),
              child: EzLoadCfg.loadViewFun(),
            ),
            Text("正在加载中",style: TextStyle(
                fontSize: EzG.gSp(25),color: EzColor.getC(EzColor.T_C_2)
            ),),
            Expanded(child: Container()),
          ],
        ),
      ),
    );
  }

  static Widget buildFaildView(f){
    return Container(
      child: Column(
        children: [
          Expanded(child: Container()),
          Container(
            child: Text("加载失败",style: TextStyle(
                fontSize: EzG.gSp(28), color: EzG.getC(EzColor.T_C_1)
            ),),
          ),
          GestureDetector(
            onTap: (){
              if(f != null){
                f();
              }
            },
            behavior: HitTestBehavior.translucent,
            child: Container(
              margin: EdgeInsets.only(top: EzG.gW(30)),
              padding: EdgeInsets.only(top: EzG.gW(14),left: EzG.gW(30),right: EzG.gW(30),bottom: EzG.gW(14)),
              child: Text("重新加载",style: TextStyle(
                  fontSize: EzG.gSp(26),fontWeight: FontWeight.w500
              ),),
              decoration: BoxDecoration(
                color: Color(0xfff3f4f4),
                borderRadius: BorderRadius.all(Radius.circular(EzG.gW(5)))
              ),
            ),
          ),
          Expanded(child: Container()),
        ],
      ),
    );
  }

  static Widget buildNodataView(f){
    return Container(
      child: Column(
        children: [
          Expanded(child: Container()),
          Container(
            child: Text("暂无数据",style: TextStyle(
                fontSize: EzG.gSp(28), color: EzG.getC(EzColor.T_C_1)
            ),),
          ),
          GestureDetector(
            onTap: (){
              if(f != null){
                f();
              }
            },
            behavior: HitTestBehavior.translucent,
            child: Container(
              margin: EdgeInsets.only(top: EzG.gW(30)),
              padding: EdgeInsets.only(top: EzG.gW(14),left: EzG.gW(30),right: EzG.gW(30),bottom: EzG.gW(14)),
              child: Text("重新加载",style: TextStyle(
                  fontSize: EzG.gSp(26),fontWeight: FontWeight.w500
              ),),
              decoration: BoxDecoration(
                  color: Color(0xfff3f4f4),
                  borderRadius: BorderRadius.all(Radius.circular(EzG.gW(5)))
              ),
            ),
          ),
          Expanded(child: Container()),
        ],
      ),
    );
  }
}
